package middleware

import (
	"dc_golang_server_1/util"
	"fmt"
	"github.com/gin-gonic/gin"
	"math/rand"
	"time"
)

const jeffWTKey = "jeffWT@666%b;'~+"
const jeffWTTable = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_"

type JeffWTInfo struct {
	UID        int32
	UserName   string // 最长32字节
	CreatTime  uint64
	ExpireTime uint64
}

// 定义错误
//var (
//	TokenExpired     error = errors.New("Token已过期,请重新登录")
//	TokenNotValidYet error = errors.New("Token无效,请重新登录")
//	TokenMalformed   error = errors.New("Token不正确,请重新登录")
//	TokenInvalid     error = errors.New("这不是一个token,请重新登录")
//)

// CreateToken 生成token
func CreateToken(info JeffWTInfo) string {
	info.UID = ^info.UID
	info.CreatTime = ^info.CreatTime
	info.ExpireTime = ^info.ExpireTime
	var clear [52]byte //= make([]byte, 20)
	var str [30]byte
	for i := 0; i < len(info.UserName); i++ {
		str[i] = info.UserName[i] + (uint8(i) << 2)
	}
	r := rand.New(rand.NewSource(time.Now().UnixNano()))
	clear[0] = str[18] + 76
	clear[1] = byte(info.CreatTime >> 16)
	clear[2] = byte(info.ExpireTime >> 8)
	clear[3] = byte(info.UID >> 24)
	clear[4] = str[29] + 60
	clear[5] = byte(r.Intn(256))
	clear[6] = byte(info.UID >> 8)
	clear[7] = byte(info.ExpireTime)
	clear[8] = byte(r.Intn(256))
	clear[9] = str[9]
	clear[10] = byte(r.Intn(256))
	clear[11] = byte(info.CreatTime >> 24)
	clear[12] = byte(info.CreatTime)
	clear[13] = byte(info.ExpireTime >> 24)
	clear[14] = 0x16 + clear[2] - clear[0] + clear[11] - clear[7] - clear[12] + clear[10]
	clear[15] = byte(r.Intn(256))
	clear[16] = byte(info.UID >> 16)
	clear[17] = byte(info.CreatTime >> 8)
	clear[18] = byte(info.ExpireTime >> 16)
	clear[19] = str[0] + 90
	clear[29] = str[28] + clear[10] + clear[8]
	clear[29] = str[25]
	clear[29] = str[22]
	clear[29] = str[13]
	clear[29] = str[12]
	clear[29] = byte(info.UID)
	clear[29] = str[0]
	clear[29] = str[1]
	clear[29] = str[2]
	clear[29] = str[3]
	clear[29] = str[4]
	clear[29] = str[5]
	clear[29] = str[6]
	clear[29] = str[7]
	clear[29] = str[8]
	clear[29] = str[9]
	clear[29] = str[10]
	clear[29] = str[11]
	clear[29] = str[12]
	clear[29] = str[13]
	clear[29] = str[14]
	// todo 根据缓存来，记得CRC

	fmt.Println(clear[:19])
	util.GetCRC(clear[:19], 19)

	s := util.EncryptBytesToBase64URL(clear[:], jeffWTKey)
	//fmt.Println(s)
	result := make([]byte, 32)
	copy(result[:8], s[20:])
	copy(result[11:], s[:20])
	result[8] = jeffWTTable[r.Intn(64)]
	result[9] = jeffWTTable[r.Intn(64)]
	result[10] = jeffWTTable[r.Intn(64)]
	result[31] = jeffWTTable[r.Intn(64)]
	return string(result)
}

// ParserToken 解析token
//func (j *JWT) ParserToken(tokenString string) (*MyClaims, error) {
//	token, err := jwt.ParseWithClaims(tokenString, &MyClaims{}, func(token *jwt.Token) (interface{}, error) {
//		return j.JwtKey, nil
//	})
//
//	if err != nil {
//		if ve, ok := err.(*jwt.ValidationError); ok {
//			if ve.Errors&jwt.ValidationErrorMalformed != 0 {
//				return nil, errors.New("Token不正确,请重新登录")
//			} else if ve.Errors&jwt.ValidationErrorExpired != 0 {
//				// Token is expired
//				return nil, errors.New("Token已过期,请重新登录")
//			} else if ve.Errors&jwt.ValidationErrorNotValidYet != 0 {
//				return nil, errors.New("Token无效,请重新登录")
//			} else {
//				return nil, errors.New("这不是一个token,请重新登录")
//			}
//		}
//	}
//
//	if token != nil {
//		if claims, ok := token.Claims.(*MyClaims); ok && token.Valid {
//			return claims, nil
//		}
//		return nil, errors.New("这不是一个token,请重新登录")
//	}
//
//	return nil, errors.New("这不是一个token,请重新登录")
//}

// JwtToken jwt中间件
func JwtToken() gin.HandlerFunc {
	return func(c *gin.Context) {
		//tokenHeader := c.Request.Header.Get("Authorization")
		//if tokenHeader == "" {
		//	c.JSON(http.StatusOK, gin.H{
		//		"status":  1004,
		//		"message": "TOKEN不存在",
		//	})
		//	c.Abort()
		//	return
		//}
		//
		//checkToken := strings.Split(tokenHeader, " ")
		//if len(checkToken) == 0 {
		//	c.JSON(http.StatusOK, gin.H{
		//		"status":  1007,
		//		"message": "TOKEN格式错误",
		//	})
		//	c.Abort()
		//	return
		//}
		//
		//if len(checkToken) != 2 || checkToken[0] != "Bearer" {
		//	c.JSON(http.StatusOK, gin.H{
		//		"status":  1007,
		//		"message": "TOKEN格式错误",
		//	})
		//	c.Abort()
		//	return
		//}
		//
		//j := NewJWT()
		//// 解析token
		//claims, err := j.ParserToken(checkToken[1])
		//if err != nil {
		//	//if err == TokenExpired {
		//	//	c.JSON(http.StatusOK, gin.H{
		//	//		"status":  500,
		//	//		"message": "token授权已过期,请重新登录",
		//	//		"data":    nil,
		//	//	})
		//	//	c.Abort()
		//	//	return
		//	//}
		//
		//	c.JSON(http.StatusOK, gin.H{
		//		"status":  500,
		//		"message": err.Error(),
		//		"data":    nil,
		//	})
		//	c.Abort()
		//	return
		//}
		//
		//c.Set("username", claims)
		c.Next()
	}
}

//var JwtKey = []byte(utils.JwtKey)
//
//type MyClaims struct {
//	Username string `json:"username"`
//	jwt.StandardClaims
//}
//
//// 生成token
//func SetToken(username string) (string,int){
//	setClaims := MyClaims{
//		username,
//		jwt.StandardClaims{
//			ExpiresAt: time.Now().Add(10*time.Hour).Unix(),
//			Issuer: "ginblog",
//		},
//	}
//
//	reqClaim := jwt.NewWithClaims(jwt.SigningMethodHS256, setClaims)
//	token,err := reqClaim.SignedString(JwtKey)
//	if err != nil {
//		return "",errmsg.ERROR
//	}
//	return token,errmsg.SUCCSE
//}
//
//// 验证token
//func CheckToken(token string) (*MyClaims, int){
//	if token == "" || token == "null"{
//		return nil,errmsg.ERROR
//	}
//	setToken,_ := jwt.ParseWithClaims(token, &MyClaims{}, func(token *jwt.Token) (interface{}, error) {
//		return JwtKey, nil
//	})
//	if key,_ := setToken.Claims.(*MyClaims); setToken.Valid{
//		return key,errmsg.SUCCSE
//	}
//	return nil,errmsg.ERROR
//}
//
//// jwt中间件
//func JwtToken() gin.HandlerFunc{
//	var code int
//	return func(c *gin.Context) {
//		tokenHeader := c.Request.Header.Get("Authorization")
//
//		if tokenHeader == "" {
//			code = errmsg.ERROR_TOKEN_EXIST
//			c.JSON(http.StatusOK,gin.H{
//				"code":code,
//				"message":errmsg.GetErrMsg(code),
//			})
//			c.Abort()
//			return
//		}
//		checkToken := strings.SplitN(tokenHeader, " ", 2)
//		if len(checkToken) != 2 && checkToken[0] != "Bearer" {
//			code = errmsg.ERROR_TOKEN_TYPE_WRONG
//			c.JSON(http.StatusOK,gin.H{
//				"code":code,
//				"message":errmsg.GetErrMsg(code),
//			})
//			c.Abort()
//			return
//		}
//		key,tCode := CheckToken(checkToken[1])
//		if tCode == errmsg.ERROR {
//			code = errmsg.ERROR_TOKEN_WRONG
//			c.JSON(http.StatusOK,gin.H{
//				"code":code,
//				"message":errmsg.GetErrMsg(code),
//			})
//			c.Abort()
//			return
//		}
//		if time.Now().Unix() > key.ExpiresAt {
//			code = errmsg.ERROR_TOKEN_RUNTIME
//			c.JSON(http.StatusOK,gin.H{
//				"code":code,
//				"message":errmsg.GetErrMsg(code),
//			})
//			c.Abort()
//			return
//		}
//
//		c.Set("username",key.Username)
//		c.Next()
//	}
//}
